class CharSet
{
	private:
		enum { NUMCHARS = 256 };
		enum { INTBITS = sizeof(int) * 8 };
		enum { ARRSIZE = NUMCHARS / INTBITS };
		int data[ARRSIZE];

	public:
		void init(const char * = "");
		CharSet operator+(const CharSet &) const;
		CharSet operator-(const CharSet &) const;
		CharSet operator*(const CharSet &) const;
		bool operator<=(const CharSet &) const;
		bool operator>=(const CharSet &) const;
		bool operator==(const CharSet &) const;
		bool operator!=(const CharSet &) const;
		bool contains(unsigned char) const;
		void print();
};