class CharSet
{
	public:
		enum { NUMCHARS = 256 };
		CharSet(const char * = "");
		CharSet operator+(const CharSet &) const;
		CharSet operator-(const CharSet &) const;
		CharSet operator*(const CharSet &) const;
		bool operator<=(const CharSet &) const;
		bool operator>=(const CharSet &) const;
		bool operator==(const CharSet &) const;
		bool operator!=(const CharSet &) const;
		bool contains(unsigned char) const;
	private:
		enum { INTBITS = sizeof(int) * 8 };
		enum { ARRSIZE = NUMCHARS / INTBITS };
		int data[ARRSIZE];
};
ostream &operator<<(ostream &out, const CharSet &string);