#ifndef TCONARR2_HPP
#define TCONARR2_HPP

class iterator
{
private:
   T *pElem;
public:
   iterator(T * = NULL); //Konstruktor
   iterator operator++(int); //T *next(T *) const;
   T &operator*() const; //Dereferenzierungsoperator
   bool operator!=(const iterator &) const; //Vergleichsoperator
};

class Tcont
{
private:
	T *pData;
	int capacity;
	int count;
	Tcont (const Tcont &); //Kopier-Konstruktor
	Tcont &operator = (const Tcont &); //Zuweisung
public:
	Tcont(); //Konstruktor
	~Tcont(); //Destruktor
	void push_front(const T&); //void push_front(const T *);
	void pop_front();
	void push_back(const T&); //void push_back(const T *);
	void pop_back();
	T &front() const; //T *front() const;
	T &back() const; //T *back() const;
	bool empty() const; //int empty() const;
	iterator begin() const; //T *begin() const;
	iterator end() const; //T *end() const;
	void checkMem (void *pv);
};

#endif //TCONARR2_HPP