/**********************************************************************\
* Dateiname: person1.cpp
* Autor    : Uhl
* Projekt  : person
*
* Kurzbeschreibung: Entwickeln Sie die Klasse Person mit 2 privaten
* Datenelementen name (Typ: char-Array) und age (Typ: int) zur Aufnahme
* des Namens und des Alters. Weiterhin sollen die Elementfunktionen
* setName(), setAge(), print() und scan() definiert werden, deren
* Schnittstellen aus dem Testprogramm hervorgehen, das fertig vorgegeben
* ist. Auf eine Fehlerabfrage bei der Eingabe des Alters soll verzichtet
* werden.
*
* Datum:     Autor:      Grund der Aenderung:
* 24.09.1999 Uhl         Neuerstellung
\**********************************************************************/

/*--- #includes der Form <...> ---------------------------------------*/

#include <iostream>
#include <cstring>

/*--- #define-Konstanten und Makros ----------------------------------*/

#define LAENGE 20

class Person
{
private:
	char name[LAENGE + 1];
	int age;
public:
	void setName(const char *pSet_name);
	void setAge(int set_age);
	void print(FILE *pPrint);
	int scan(FILE *pScan);
};

void Person::setName(const char *pSet_name)
{ //
	strcpy(name, pSet_name);
}

void Person::setAge(int set_age)
{ 
	age = set_age;
}

void Person::print(FILE *pPrint)
{
	fprintf(pPrint, "%s %d\n", name, age);
}

int Person::scan(FILE *pScan)
{
	return fscanf(pScan, "%s%d", name, &age);
}

int main(void)
{
	Person father, mother, myself;

	father.setName("Karl");
	father.setAge(55);
	mother.setName("Brigitte");
	mother.setAge(51);

	printf("Bitte Vorname und Alter (durch Leerzeichen getrennt) eingeben: ");
	myself.scan(stdin);

	Person son;
	son = myself;
	son.setAge(2);

	father.print(stdout);
	mother.print(stdout);
	myself.print(stdout);
	son.print(stdout);

	return 0;
}