/**********************************************************************\
* Dateiname: person2.cpp
* Autor    : Uhl
* Projekt  : person2
\**********************************************************************/

#include <iostream>
#include <cstring>

using namespace std;

#define LAENGE 20

class Person
{
private:
	char name[LAENGE + 1];
	int age;
public:
	void setName(char *pSet_name);
	void setAge(int set_age);
	const char *getName() const {return name;}
	int getAge() const {return age;}
};

void Person::setName(char *pSet_name)
{ 
	strcpy(name, pSet_name);
}

void Person::setAge(int set_age)
{ 
	age = set_age;
}

ostream &operator << (ostream &Ausgabe, const Person &pers)
{
	return Ausgabe << pers.getName() << ' ' << pers.getAge() << '\n';
}

istream &operator >> (istream &Eingabe, Person &pers)
{
	char buffer[LAENGE + 1];
	int age;

	Eingabe >> buffer >> age;
	pers.setName(buffer);
	pers.setAge(age);
	return Eingabe;
}

int main(void)
{
	Person father, mother, myself;

	father.setName("Karl");
	father.setAge(55);
	mother.setName("Brigitte");
	mother.setAge(51);

	cout << "Bitte Vorname und Alter (durch Leerzeichen getrennt) eingeben: ";
	cin >> myself;

	Person son;
	son = myself;
	son.setAge(2);

	cout << father;
	cout << mother;
	cout << myself;
	cout << son;

	return 0;
}