#include <iostream>
#include <cstring>

using namespace std;

#include "person4.hpp"


Person::Person(const char *pName, int set_age) //Standartkonstruktor
{
	if((pSet_name = new char[strlen(pName)+1]) != NULL)
		strcpy(pSet_name, pName);
	age = set_age;
}

void Person::setName(const char *pName) //Name wird gesetzt
{ 
	if (pSet_name != pName)
	{
		delete [] pSet_name;
		if((pSet_name = new char[strlen(pName)+1]) != NULL)
			strcpy(pSet_name, pName);
	}
}

void Person::setAge(int set_age) //Alter wird gesetzt
{ 
	age = set_age;
}

Person::Person(const Person &pers) //Kopier-Konstruktor
{
	if((pSet_name = new char[strlen(pers.pSet_name)+1]) != NULL)
		strcpy(pSet_name, pers.pSet_name);
	age = pers.age;
}

Person &Person::operator=(const Person &pers) //Zuweisungung
{
	if( this == &pers )
		return *this;
	setName(pers.getName());
	setAge(pers.getAge());
	return *this;
}

const char *Person::getName(void) const //Name wird aus "Privat" geholt
{
	return pSet_name;
}

int Person::getAge(void) const //Alter wird aus "Privat" geholt
{
	return age;
}

Person::~Person() //Destruktor
{
	delete [] pSet_name;
}