/**********************************************************************\
* Dateiname: tcont.cpp
* Autor    : Uhl
* Projekt  : cont5
\**********************************************************************/

/*--- #includes der Form <...> ---------------------------------------*/

#include <stdio.h>

/*--- #includes der Form "..." ---------------------------------------*/

#include "t.h"
#include "tconarr.hpp"

/*--- #define-Konstanten und Makros ----------------------------------*/

/*--- Datentypen (typedef) -------------------------------------------*/

/*--- Globale Konstanten ---------------------------------------------*/

/*--- Globale Variablen ----------------------------------------------*/

/*--- Modullokale Konstanten -----------------------------------------*/

/*--- Modullokale Variablen ------------------------------------------*/

/*--- Prototypen modullokaler Funktionen -----------------------------*/

/*--- Funktionsdefinitionen ------------------------------------------*/

int main(void)
{
	Tcont cont;
	char cmd;          /* Funktionsauswahl                             */
	T buffer;          /* Zwischenspeicherung eines Container-Elements */
	T *pElem;          /* Iterieren ueber alle Container-Elemente      */

	/* Test der assert() Aufrufe:
	"Entkommentieren" Sie jeweils eine der folgenden Anweisungen
	und ueberpruefen Sie auf diese Weise, ob die unzulssigen
	Funktionsaufrufe entdeckt werden und das Programm mit einer
	entsprechenden Fehlermeldung abgebrochen wird:
	*/

	/* pop_front(); */
	/* pop_back();  */
	/* front();     */
	/* back();      */

	do                          /* solange, bis Funktion quit gewaehlt */
	{
		printf("1=push_front 2=push_back 3=pop_front 4=pop_back "
			"5=front 6=back 7=show q=quit: ");
		fflush(stdin);
		cmd = getchar();
		switch (cmd)
		{
		case '1':
			printf("push_front, ");
			scanT(&buffer);
			cont.push_front(&buffer);
			break;

		case '2':
			printf("push_back, ");
			scanT(&buffer);
			cont.push_back(&buffer);
			break;

		case '3':
			if (!cont.empty())
				cont.pop_front();
			else
				printf("---Container leer---\n");
			break;

		case '4':
			if (!cont.empty())
				cont.pop_back();
			else
				printf("---Container leer---\n");
			break;

		case '5':
			if (!cont.empty())
			{
				printf("cont.front:\n");
				printT(cont.front());
			}
			else
				printf("---Container leer---\n");
			break;

		case '6':
			if (!cont.empty())
			{
				printf("cont.back:\n");
				printT(cont.back());
			}
			else
				printf("---Container leer---\n");
			break;

		case '7':
			printf("show:\n");
			for (pElem = cont.begin(); pElem != cont.end(); pElem = cont.next(pElem))
				printT(pElem);
			break;

		case 'q':
			break;

		default:
			printf("unerlaubtes Zeichen\n");
		}
	} while (cmd != 'q');
	return 0;
}

/* Ein-/Ausgabe (eine von vielen moeglichen):
-------------------------------------------------------------------------------
1=push_front 2=push_back 3=pop_front 4=pop_back 5=front 6=back 7=show q=quit: 1
push_front, int-Zahl: 11
1=push_front 2=push_back 3=pop_front 4=pop_back 5=front 6=back 7=show q=quit: 1
push_front, int-Zahl: 22
1=push_front 2=push_back 3=pop_front 4=pop_back 5=front 6=back 7=show q=quit: 2
push_back, int-Zahl: 99
1=push_front 2=push_back 3=pop_front 4=pop_back 5=front 6=back 7=show q=quit: 7
show:
22
11
99
1=push_front 2=push_back 3=pop_front 4=pop_back 5=front 6=back 7=show q=quit: q
-----------------------------------------------------------------------------*/