#include <iostream>

using namespace std;

#include "date.hpp"
#include "gerdate.hpp"

bool GermanDate::longFormat = false;

ostream &operator<<(ostream &os, const GermanDate &gd)
{
	const char *pger_month[] = { "Januar", "Februar", "Mrz",
		"April", "Mai", "Juni", "Juli", "August", "September",
		"Oktober", "November", "Dezember" };

	if( GermanDate::longFormat )
		return os << gd.day << ". " << pger_month[gd.month-1] << " " << gd.year;
	else
		return os << gd.day << "." << gd.month << "." << gd.year;
}