/**********************************************************************\
* Dateiname: person3.cpp
* Autor    : Uhl
* Projekt  : person3
\**********************************************************************/

#include <iostream>
#include <cstring>

using namespace std;

#define LAENGE 20

class Person
{
private:
	char name[LAENGE + 1];
	int age;
public:
	Person () {} //Standartkonstruktor
	Person(const char *pSet_name, int set_age);
	void setName(const char *pSet_name);
	void setAge(int set_age);
	const char *getName() const {return name;}
	int getAge() const {return age;}
};

Person::Person(const char *pSet_name, int set_age)
{
	strcpy(name, pSet_name);
	age = set_age;
}

void Person::setName(const char *pSet_name)
{ 
	strcpy(name, pSet_name);
}

void Person::setAge(int set_age)
{ 
	age = set_age;
}

ostream &operator<<(ostream &Ausgabe, const Person &person)
{
	return Ausgabe << person.getName() << ' ' << person.getAge() << '\n';
}

istream &operator>>(istream &Eingabe, Person &person)
{
	char buffer[LAENGE + 1];
	int age;

	Eingabe >> buffer >> age;
	person.setName(buffer);
	person.setAge(age);
	return Eingabe;
}

int main(void)
{
	const Person father("Karl", 55), mother("Brigitte", 51);
	Person myself, another;

	cout << "Bitte Vorname und Alter (durch Leerzeichen getrennt) eingeben: ";
	cin >> myself;

	Person son(myself); // (vom Compiler erzeugter?) Kopier-Konstruktor
	son.setAge(2);
	another = son;      // (vom Compiler erzeugter?) Zuweisungsoperator

	// nicht sinnvoll, aber muss moeglich sein
	son = son;

	// nicht sinnvoll, aber muss moeglich sein
	son.setName(son.getName());

	cout << father;
	cout << mother;
	cout << myself;
	cout << son;
	cout << another;

	return 0;
}